'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _web3_tools = require('../utils/web3_tools');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GenesisContractWrapper = function () {
  function GenesisContractWrapper(address, contractJson, web3, defaultAddress) {
    (0, _classCallCheck3.default)(this, GenesisContractWrapper);

    if (address === undefined) {
      throw new Error('address is not configured');
    }

    this.web3 = web3;
    this.defaultAddress = defaultAddress;
    this.contract = (0, _web3_tools.loadContract)(this.web3, contractJson.abi, address);
  }

  (0, _createClass3.default)(GenesisContractWrapper, [{
    key: 'setDefaultAddress',
    value: function setDefaultAddress(defaultAddress) {
      this.defaultAddress = defaultAddress;
    }
  }, {
    key: 'getOwner',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', this.contract.methods.owner().call());

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getOwner() {
        return _ref.apply(this, arguments);
      }

      return getOwner;
    }()
  }, {
    key: 'transferOwnership',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(newOwnerAddress) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', this.contract.methods.transferOwnership(newOwnerAddress).send({ from: this.defaultAddress }));

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function transferOwnership(_x) {
        return _ref2.apply(this, arguments);
      }

      return transferOwnership;
    }()
  }, {
    key: 'address',
    value: function address() {
      return this.contract.options.address;
    }
  }]);
  return GenesisContractWrapper;
}(); /*
     Copyright: Ambrosus Technologies GmbH
     Email: tech@ambrosus.com
     
     This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.
     
     This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
     */

exports.default = GenesisContractWrapper;