'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _web3_tools = require('../utils/web3_tools');

var _contract_jsons = require('../contract_jsons');

var _contract_jsons2 = _interopRequireDefault(_contract_jsons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** @abstract */
/*
Copyright: Ambrosus Technologies GmbH
Email: tech@ambrosus.com

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var ManagedContractWrapper = function () {
  function ManagedContractWrapper(headWrapper, web3, defaultAddress) {
    (0, _classCallCheck3.default)(this, ManagedContractWrapper);

    this.headWrapper = headWrapper;
    this.web3 = web3;
    this.defaultAddress = defaultAddress;
  }

  (0, _createClass3.default)(ManagedContractWrapper, [{
    key: 'address',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', this.headWrapper.contractAddressByName(this.getContractName));

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function address() {
        return _ref.apply(this, arguments);
      }

      return address;
    }()
  }, {
    key: 'contract',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var contractAddress;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.headWrapper.contractAddressByName(this.getContractName);

              case 2:
                contractAddress = _context2.sent;
                return _context2.abrupt('return', (0, _web3_tools.loadContract)(this.web3, _contract_jsons2.default[this.getContractName].abi, contractAddress));

              case 4:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function contract() {
        return _ref2.apply(this, arguments);
      }

      return contract;
    }()
  }, {
    key: 'processTransaction',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(transactionObject) {
        var sendParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt('return', transactionObject.send((0, _extends3.default)({ from: this.defaultAddress }, sendParams)));

              case 1:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function processTransaction(_x) {
        return _ref3.apply(this, arguments);
      }

      return processTransaction;
    }()
  }, {
    key: 'setDefaultAddress',
    value: function setDefaultAddress(defaultAddress) {
      this.defaultAddress = defaultAddress;
    }
  }, {
    key: 'getContractName',
    get: function get() {
      throw new Error('Abstract method getContractName needs to be overridden');
    }
  }]);
  return ManagedContractWrapper;
}();

exports.default = ManagedContractWrapper;